import { EngineConfig, Operation, Operator } from 'types';
interface OperationContext {
    data: Record<string, any>;
    prev: {
        args?: Record<string, any>;
        result?: any;
    }[];
    env: EngineConfig['env'];
}
export declare const interpolationRegex: RegExp;
export declare class Engine {
    protected config: EngineConfig;
    private operators;
    constructor(operators: Record<string, Operator>, config: EngineConfig);
    static validateConfig(config: EngineConfig): void;
    static validateOperators(operators: Record<string, Operator>): void;
    static validateOperation(operation: Operation): void;
    getOperatorList(): Record<'operator' | 'name' | 'description', string>[];
    addOperators(newOperators: Record<string, Operator>): void;
    removeOperators(operatorKeys: string[]): void;
    runOperation(operation: Operation, dataSource?: Record<string, any>): Promise<any>;
    protected executeOperation(operation: Operation, context: OperationContext): Promise<any>;
    protected mountOperatorInput(args: any, context: OperationContext): Promise<any>;
    protected handleStringInterpolation(str: string, context: OperationContext): string;
}
export {};
